Loading...
Searching...
No Matches
Exiv2::ValueType< T > Class Template Reference

Template for a Value of a basic type. This is used for unsigned and signed short, long and rationals. More...

`#include <value.hpp>`

Inheritance diagram for Exiv2::ValueType< T >:
[legend]

## Public Types

typedef std::auto_ptr< ValueType< T > > | AutoPtr
| Shortcut for a ValueType<T> auto pointer.
Public Types inherited from Exiv2::Value
typedef std::auto_ptr< Value > | AutoPtr
| Shortcut for a Value auto pointer.

## Public Member Functions

long | toLong (long n) const
| Convert the n-th component of the value to a long. The behaviour of this method may be undefined if there is no n-th component.
long | toLong (long n) const
| Convert the n-th component of the value to a long. The behaviour of this method may be undefined if there is no n-th component.
long | toLong (long n) const
| Convert the n-th component of the value to a long. The behaviour of this method may be undefined if there is no n-th component.
long | toLong (long n) const
| Convert the n-th component of the value to a long. The behaviour of this method may be undefined if there is no n-th component.
float | toFloat (long n) const
| Convert the n-th component of the value to a float. The behaviour of this method may be undefined if there is no n-th component.
float | toFloat (long n) const
| Convert the n-th component of the value to a float. The behaviour of this method may be undefined if there is no n-th component.
Rational | toRational (long n) const
| Convert the n-th component of the value to a Rational. The behaviour of this method may be undefined if there is no n-th component.
Rational | toRational (long n) const
| Convert the n-th component of the value to a Rational. The behaviour of this method may be undefined if there is no n-th component.
Rational | toRational (long n) const
| Convert the n-th component of the value to a Rational. The behaviour of this method may be undefined if there is no n-th component.
Rational | toRational (long n) const
| Convert the n-th component of the value to a Rational. The behaviour of this method may be undefined if there is no n-th component.
Creators
| ValueType ()
| Default Constructor.
| ValueType (TypeId typeId)
| Constructor.
| ValueType (const byte *buf, long len, ByteOrder byteOrder, TypeId typeId=getType< T >())
| Constructor.
| ValueType (const T &val, TypeId typeId=getType< T >())
| Constructor.
| ValueType (const ValueType< T > &rhs)
| Copy constructor.
virtual | ~ValueType ()
| Virtual destructor.
Manipulators
ValueType< T > & | operator= (const ValueType< T > &rhs)
| Assignment operator.
virtual int | read (const byte *buf, long len, ByteOrder byteOrder)
| Read the value from a character buffer.
virtual int | read (const std::string &buf)
| Set the data from a string of values of type T (e.g., "0 1 2 3" or "1/2 1/3 1/4" depending on what T is). Generally, the accepted input format is the same as that produced by the write() method.
virtual int | setDataArea (const byte *buf, long len)
| Set the data area. This method copies (clones) the buffer pointed to by buf.
Public Member Functions inherited from Exiv2::Value
| Value (TypeId typeId)
| Constructor, taking a type id to initialize the base class with.
virtual | ~Value ()
| Virtual destructor.
TypeId | typeId () const
| Return the type identifier (Exif data format type).
AutoPtr | clone () const
| Return an auto-pointer to a copy of itself (deep copy). The caller owns this copy and the auto-pointer ensures that it will be deleted.
std::string | toString () const
| Return the value as a string. Implemented in terms of write(std::ostream& os) const of the concrete class.
bool | ok () const
| Check the ok status indicator. After a to<Type> conversion, this indicator shows whether the conversion was successful.

## Accessors

typedef std::vector< T > | ValueList
| Container for values.
typedef std::vector< T >::iterator | iterator
| Iterator type defined for convenience.
typedef std::vector< T >::const_iterator | const_iterator
| Const iterator type defined for convenience.
ValueList | value_
| The container for all values. In your application, if you know what subclass of Value you're dealing with (and possibly the T) then you can access this STL container through the usual standard library functions.
AutoPtr | clone () const
virtual long | copy (byte *buf, ByteOrder byteOrder) const
| Write value to a data buffer.
virtual long | count () const
| Return the number of components of the value.
virtual long | size () const
| Return the size of the value in bytes.
virtual std::ostream & | write (std::ostream &os) const
| Write the value to an output stream. You do not usually have to use this function; it is used for the implementation of the output operator for Value, operator<<(std::ostream &os, const Value &value).
virtual std::string | toString (long n) const
| Return the n-th component of the value as a string. The behaviour of this method may be undefined if there is no n-th component.
virtual long | toLong (long n=0) const
| Convert the n-th component of the value to a long. The behaviour of this method may be undefined if there is no n-th component.
virtual float | toFloat (long n=0) const
| Convert the n-th component of the value to a float. The behaviour of this method may be undefined if there is no n-th component.
virtual Rational | toRational (long n=0) const
| Convert the n-th component of the value to a Rational. The behaviour of this method may be undefined if there is no n-th component.
virtual long | sizeDataArea () const
| Return the size of the data area.
virtual DataBuf | dataArea () const
| Return a copy of the data area in a DataBuf. The caller owns this copy and DataBuf ensures that it will be deleted.

## Additional Inherited Members

Static Public Member Functions inherited from Exiv2::Value
static AutoPtr | create (TypeId typeId)
| A (simple) factory to create a Value type.
Protected Member Functions inherited from Exiv2::Value
Value & | operator= (const Value &rhs)
| Assignment operator. Protected so that it can only be used by subclasses but not directly.
Protected Attributes inherited from Exiv2::Value
bool | ok_
| Indicates the status of the previous to<Type> conversion.

## Detailed Description

template<typename T>
class Exiv2::ValueType< T >

Template for a Value of a basic type. This is used for unsigned and signed short, long and rationals.

Examples
  addmoddel.cpp.

## Member Function Documentation

## copy()

template<typename T >

long Exiv2::ValueType< T >::copy | ( | byte * | buf,
|  | ByteOrder | byteOrder
| ) |  | const

virtual

Write value to a data buffer.

The user must ensure that the buffer has enough memory. Otherwise the call results in undefined behaviour.

Parameters

  buf | Data buffer to write to.
  byteOrder | Applicable byte order (little or big endian).

Returns
  Number of bytes written.

Implements Exiv2::Value.

References Exiv2::toData().

## count()

template<typename T >

long Exiv2::ValueType< T >::count | ( |  | ) | const

virtual

Return the number of components of the value.

Implements Exiv2::Value.

## dataArea()

template<typename T >

DataBuf Exiv2::ValueType< T >::dataArea | ( |  | ) | const

virtual

Return a copy of the data area in a DataBuf. The caller owns this copy and DataBuf ensures that it will be deleted.

Reimplemented from Exiv2::Value.

## read() [1/2]

template<typename T >

int Exiv2::ValueType< T >::read | ( | const byte * | buf,
|  | long | len,
|  | ByteOrder | byteOrder
| ) |  |

virtual

Read the value from a character buffer.

Parameters

  buf | Pointer to the data buffer to read from
  len | Number of bytes in the data buffer
  byteOrder | Applicable byte order (little or big endian).

Returns
  0 if successful.

Implements Exiv2::Value.

References Exiv2::TypeInfo::typeSize().

Referenced by Exiv2::ValueType< T >::ValueType().

## read() [2/2]

template<typename T >

int Exiv2::ValueType< T >::read | ( | const std::string & | buf | ) |

virtual

Set the data from a string of values of type T (e.g., "0 1 2 3" or "1/2 1/3 1/4" depending on what T is). Generally, the accepted input format is the same as that produced by the write() method.

Implements Exiv2::Value.

## setDataArea()

template<typename T >

int Exiv2::ValueType< T >::setDataArea | ( | const byte * | buf,
|  | long | len
| ) |  |

virtual

Set the data area. This method copies (clones) the buffer pointed to by buf.

Reimplemented from Exiv2::Value.

## size()

template<typename T >

long Exiv2::ValueType< T >::size | ( |  | ) | const

virtual

Return the size of the value in bytes.

Implements Exiv2::Value.

References Exiv2::TypeInfo::typeSize().

## sizeDataArea()

template<typename T >

long Exiv2::ValueType< T >::sizeDataArea | ( |  | ) | const

virtual

Return the size of the data area.

Reimplemented from Exiv2::Value.

## toFloat() [1/3]

float Exiv2::ValueType< Rational >::toFloat | ( | long | n | ) | const

inline virtual

Convert the n-th component of the value to a float. The behaviour of this method may be undefined if there is no n-th component.

Returns
  The converted value.

Implements Exiv2::Value.

## toFloat() [2/3]

float Exiv2::ValueType< URational >::toFloat | ( | long | n | ) | const

inline virtual

Convert the n-th component of the value to a float. The behaviour of this method may be undefined if there is no n-th component.

Returns
  The converted value.

Implements Exiv2::Value.

## toFloat() [3/3]

template<typename T >

float Exiv2::ValueType< T >::toFloat | ( | long | n = `0` | ) | const

virtual

Convert the n-th component of the value to a float. The behaviour of this method may be undefined if there is no n-th component.

Returns
  The converted value.

Implements Exiv2::Value.

## toLong() [1/5]

long Exiv2::ValueType< double >::toLong | ( | long | n | ) | const

inline virtual

Convert the n-th component of the value to a long. The behaviour of this method may be undefined if there is no n-th component.

Returns
  The converted value.

Implements Exiv2::Value.

## toLong() [2/5]

long Exiv2::ValueType< float >::toLong | ( | long | n | ) | const

inline virtual

Convert the n-th component of the value to a long. The behaviour of this method may be undefined if there is no n-th component.

Returns
  The converted value.

Implements Exiv2::Value.

## toLong() [3/5]

long Exiv2::ValueType< Rational >::toLong | ( | long | n | ) | const

inline virtual

Convert the n-th component of the value to a long. The behaviour of this method may be undefined if there is no n-th component.

Returns
  The converted value.

Implements Exiv2::Value.

## toLong() [4/5]

long Exiv2::ValueType< URational >::toLong | ( | long | n | ) | const

inline virtual

Convert the n-th component of the value to a long. The behaviour of this method may be undefined if there is no n-th component.

Returns
  The converted value.

Implements Exiv2::Value.

## toLong() [5/5]

template<typename T >

long Exiv2::ValueType< T >::toLong | ( | long | n = `0` | ) | const

virtual

Convert the n-th component of the value to a long. The behaviour of this method may be undefined if there is no n-th component.

Returns
  The converted value.

Implements Exiv2::Value.

## toRational() [1/5]

Rational Exiv2::ValueType< Rational >::toRational | ( | long | n | ) | const

inline virtual

Convert the n-th component of the value to a Rational. The behaviour of this method may be undefined if there is no n-th component.

Returns
  The converted value.

Implements Exiv2::Value.

## toRational() [2/5]

Rational Exiv2::ValueType< URational >::toRational | ( | long | n | ) | const

inline virtual

Convert the n-th component of the value to a Rational. The behaviour of this method may be undefined if there is no n-th component.

Returns
  The converted value.

Implements Exiv2::Value.

## toRational() [3/5]

Rational Exiv2::ValueType< float >::toRational | ( | long | n | ) | const

inline virtual

Convert the n-th component of the value to a Rational. The behaviour of this method may be undefined if there is no n-th component.

Returns
  The converted value.

Implements Exiv2::Value.

References Exiv2::floatToRationalCast().

## toRational() [4/5]

Rational Exiv2::ValueType< double >::toRational | ( | long | n | ) | const

inline virtual

Convert the n-th component of the value to a Rational. The behaviour of this method may be undefined if there is no n-th component.

Returns
  The converted value.

Implements Exiv2::Value.

References Exiv2::floatToRationalCast().

## toRational() [5/5]

template<typename T >

Rational Exiv2::ValueType< T >::toRational | ( | long | n = `0` | ) | const

virtual

Convert the n-th component of the value to a Rational. The behaviour of this method may be undefined if there is no n-th component.

Returns
  The converted value.

Implements Exiv2::Value.

## toString()

template<typename T >

std::string Exiv2::ValueType< T >::toString | ( | long | n | ) | const

virtual

Return the n-th component of the value as a string. The behaviour of this method may be undefined if there is no n-th component.

Reimplemented from Exiv2::Value.

## write()

template<typename T >

std::ostream & Exiv2::ValueType< T >::write | ( | std::ostream & | os | ) | const

virtual

Write the value to an output stream. You do not usually have to use this function; it is used for the implementation of the output operator for Value, operator<<(std::ostream &os, const Value &value).

Implements Exiv2::Value.

The documentation for this class was generated from the following file:

- value.hpp